#include "demo.h"
#include "tga.h"

#define GRIS(x)     (((x)<<16)|((x)<<8)|(x))


// Reserva meoria para una textura
P_TEXTURE_IMAGE AllocateTextureBuffer(int w, int h)
{
	P_TEXTURE_IMAGE ti=NULL;
	unsigned char *c=NULL;

	ti = (P_TEXTURE_IMAGE)malloc(sizeof(TEXTURE_IMAGE));		

	if( ti != NULL ) {
		ti->width  = w;											
		ti->height = h;											
		ti->data = (unsigned char *)malloc( w * h * 4);
	}
	else
		return NULL;
	return ti;													
}

// Libera la memoria de una textura
void DeallocateTexture( P_TEXTURE_IMAGE t )
{
	if(t){
		if(t->data)
			free(t->data);
		free(t);
	}
}

void ActivarTextura(int id)
{
	glBindTexture(GL_TEXTURE_2D, texture[id]);
}
	

void InitTGATexture(char *file, int tex)
{
	int h;
	int err;

	gliGenericImage *j;
	FILE *f;
	f= fopen(file, "rb");
	j = gliReadTGA(f, "f1");
	fclose(f);

	for (h=3; h<(j->width*j->height*4);h+=4){
		j->pixels[h] = ((j->pixels[h]==0x00) ? 0xff: 0x00);
	}

	//    tex->data = j->pixels;
	glBindTexture(GL_TEXTURE_2D, texture[tex]);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

	// Generate The Texture
	err = gluBuild2DMipmaps(GL_TEXTURE_2D, j->components, j->width, j->height, j->format, GL_UNSIGNED_BYTE, j->pixels);
}

void InitTextures()
{
	/// CARGAR LAS TEXTURAS.........

	InitTGATexture("data/titulo1.tga",TEXTURA_titulo1);
	InitTGATexture("data/smile1.tga",TEXTURA_smile1);	
	InitTGATexture("data/smile2.tga",TEXTURA_smile2);
	InitTGATexture("data/smile3.tga",TEXTURA_smile3);
	InitTGATexture("data/smile4.tga",TEXTURA_smile4);
	InitTGATexture("data/smile5.tga",TEXTURA_smile5);
	InitTGATexture("data/smile6.tga",TEXTURA_smile6);
	InitTGATexture("data/smile7.tga",TEXTURA_smile7);
	InitTGATexture("data/smile8.tga",TEXTURA_smile8);	
	InitTGATexture("data/smile9.tga",TEXTURA_smile9);	
	InitTGATexture("data/smile10.tga",TEXTURA_smile10);
	InitTGATexture("data/smile11.tga",TEXTURA_smile11);
	InitTGATexture("data/smile12.tga",TEXTURA_smile12);
	InitTGATexture("data/todos1.tga",TEXTURA_todos1);
	
}
